SystemOrganization addCategory: #MetaTalk!

TestCase subclass: #StackMachineTest
	instanceVariableNames: 'SM'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!StackMachineTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 12:29'!
setUp

	SM := StackMachine.
	SM clear.! !

!StackMachineTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 12:50'!
testAt

	SM new.
	SM push: 3.
	self assert: (SM at: 1) = 3.
	! !

!StackMachineTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 12:50'!
testAtPut

	SM new.
	SM push: 3.
	self assert: (SM at: 1) = 3.
	SM at: 1 put: 10.
	self assert: (SM at: 1) = 10.
	! !

!StackMachineTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 13:08'!
testBlockSendWithReturn! !

!StackMachineTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 15:22'!
testMessageSend

	"3.0 + 4 / 5"

	SM new.
	SM push: (ObjectNumberRepresentation new hostNumberRepresentation: 3.0).
	SM push: (ObjectNumberRepresentation new hostNumberRepresentation: 4).
	PrimitiveCall numberAdd.
	SM push: (ObjectNumberRepresentation new hostNumberRepresentation: 5).
	PrimitiveCall numberDiv.
	self assert: (SM pop hostNumberRepresentation = 1.4)
	! !

!StackMachineTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 15:29'!
testMessageSendWithReturn

	SM new.
	SM push: (ObjectNumberRepresentation new hostNumberRepresentation: 3.0).
	SM push: (ObjectNumberRepresentation new hostNumberRepresentation: 4).
	SM new.
	SM push: SM prev pop.
	SM push: SM prev pop.
	PrimitiveCall numberAdd.
	SM prev push: SM pop.
	SM remove.
	SM push: (ObjectNumberRepresentation new hostNumberRepresentation: 5).
	PrimitiveCall numberDiv.
	self assert: (SM pop hostNumberRepresentation = 1.4)
	! !

!StackMachineTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 12:46'!
testNew

	self assert: (SM new class = StackMachine).! !

TestCase subclass: #SymbolTableTest
	instanceVariableNames: 'ST'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!SymbolTableTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2011 13:21'!
setUp

	ST := SymbolTable.
	ST clear.! !

!SymbolTableTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2011 13:20'!
testSearch

	|entry|

	SymbolTable new.
	SymbolTable add: (SymbolTableEntry new name: 'Object').
	SymbolTable new.
	SymbolTable add: (SymbolTableEntry new name: 'Class').
	entry := SymbolTable search: 'Object'.
	self assert: (entry offset = -1).
	self assert: (entry genReadCode =  ' (SM  stackAt: -1) at: 1').
	! !

!SymbolTableTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2011 13:04'!
testSearchMethod

	|entry|

	SymbolTable new.
	SymbolTable add: (SymbolTableEntry new name: 'Object').
	SymbolTable addMethod: (SymbolMethodEntry new name: 'at:put').
	SymbolTable new.
	SymbolTable add: (SymbolTableEntry new name: 'Class').
	entry := SymbolTable search: 'Object'.
	self assert: (entry offset = -1).
	self assert: (entry genReadCode =  ' (SM  stackAt: -1) at: 1').
	entry := SymbolTable searchMethod: 'at:put'.
	self assert: (entry index = 1).
	! !

PPCompositeParser subclass: #MetaTalkGrammar
	instanceVariableNames: 'identifier keyword string number boolean messageSend unaryMessage binaryMessage keywordMessage binarySelector expression precedenceExp statement baseExpr varAssignment varDeclaration methodDeclaration classDeclaration blockClosure list methodClosure argument dict returnStatement char primitive'
	classVariableNames: 'arguments ivs message superName'
	poolDictionaries: ''
	category: 'MetaTalk'!

!MetaTalkGrammar class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/19/2011 14:00'!
flatten: aCollection

	|flatCollection|
	
	flatCollection := OrderedCollection new.
	(aCollection isCollection & aCollection isString not) ifTrue: [
		aCollection do: [:item | 
			(item isCollection & item isString not) ifTrue: [
				flatCollection addAll: (self flatten: item).
			] ifFalse: [
				flatCollection add: item.
			].
		].
		^ flatCollection.
	] ifFalse: [
		^ aCollection.
	] ! !

!MetaTalkGrammar class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/18/2011 16:18'!
parse: aString

	"initialise SymbolTable and then parse".
	
	SymbolTable clear.
	SymbolTable new.
	SymbolTable add: (SymbolLocalVarEntry new name: 'nil').
	SymbolTable add: (SymbolLocalVarEntry new name: 'true').
	SymbolTable add: (SymbolLocalVarEntry new name: 'false').
	SymbolTable add: (SymbolClassEntry new name: 'Object').
	SymbolTable add: (SymbolClassEntry new name: 'Class').
	SymbolTable add: (SymbolClassEntry new name: 'Block').
	SymbolTable add: (SymbolClassEntry new name: 'UndefinedObject').
	SymbolTable add: (SymbolClassEntry new name: 'Number').
	SymbolTable add: (SymbolClassEntry new name: 'Char').
	SymbolTable add: (SymbolClassEntry new name: 'Boolean').
	SymbolTable add: (SymbolClassEntry new name: 'True').
	SymbolTable add: (SymbolClassEntry new name: 'False').
	SymbolTable add: (SymbolClassEntry new name: 'List').
	SymbolTable add: (SymbolClassEntry new name: 'String').
	SymbolTable add: (SymbolClassEntry new name: 'Dict').
	^ super parse: aString.! !

!MetaTalkGrammar methodsFor: 'tokens' stamp: 'NickPapoulias 5/17/2011 23:57'!
argument

	^ ($: asParser, (#word asParser plus) flatten) trim ==> [:nodes | nodes at: 2].! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/19/2011 12:56'!
baseExpr 

	^ ( (identifier ==> [:value | {'SM push: ' , (SymbolTable search: value) genReadCode.} asOrderedCollection]) / 
	boolean / 
	number / 
	char /  
	string / 
	list / 
	dict / 
	blockClosure / 
	precedenceExp) ==> [:node | node asOrderedCollection]! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/19/2011 14:26'!
binaryMessage

	^ ((unaryMessage / baseExpr) , (binarySelector , (unaryMessage / baseExpr)) plus) ==> [:nodes | 		
		|code messages argsCode initialReceiverCode methodIndexes|
		messages := (nodes at: 2) collect: [:n | n at: 1].
		argsCode := ((nodes at: 2) collect: [:n | n at: 2]) reversed.
		initialReceiverCode := nodes at: 1.
		methodIndexes := messages collect: [:m | (SymbolTable addMethod: ((SymbolMethodEntry new) name: m)) index asString].
		code := argsCode copy asOrderedCollection.
		code addAll: initialReceiverCode.
		methodIndexes do: [:mIndex | code add: 'PrimitiveCall call: ' , mIndex. ].
		code.
	].! !

!MetaTalkGrammar methodsFor: 'tokens' stamp: 'NickPapoulias 5/16/2011 15:04'!
binarySelector
	"comment stating purpose of message"

	^ ($/ asParser / $% asParser / $* asParser / $+ asParser / $- asParser /  $< asParser / $> asParser  / $| asParser / $& asParser   / '==' asParser / $= asParser ) token trim ==> [:token | token value].! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/19/2011 15:15'!
blockClosure

	^ (( ($[ asParser trim , ( (argument plus , $| asParser token trim) optional ==> [:nodes | nodes ifNotNil: [ nodes at: 1 ] ifNil: [ {} ]] )) ==> [:nodes |
			
			|arguments code|
			
			arguments := nodes at: 2.
			code := {} asOrderedCollection.
			
			SymbolTable new.
			arguments ifNotEmpty: [
				arguments do: [:arg | SymbolTable add: (SymbolArgEntry new name: arg)].
			].

			code add: 'StackMachine new.'.
			arguments ifNotEmpty: [ 
				code add: 'StackMachine push: StackMachine prev pop'.
			].
			code.

	  ]) , ((varDeclaration optional) ==> [:nodes | 
			
			|locals code|
			
			locals := nodes.
			code := {} asOrderedCollection.
			
			locals ifNotNil: [
				locals do: [:local | SymbolTable add: (SymbolLocalVarEntry new name: local)].
			].
			
			locals ifNotNil: [
				code add: 'StackMachine pushNil.'.
			].
			code.
			
	]) , statement star , $] asParser trim ) ==> [:nodes |
	
			|code createBlockCode|
			SymbolTable end.
			code := OrderedCollection new.
			code addAll: (nodes at: 1).
			code addAll: (nodes at: 2).
			code addAll: (nodes at: 3).
			code add:  'StackMachine silentReturn.'.
			code := MetaTalkGrammar flatten: code.
			createBlockCode := {'StackMachine pushBlock: ' ,  '{' , (code inject: '' into: [:block :cmd | block , '''' , cmd asString , '''' , ' . ']) , '}'.} asOrderedCollection.
	].! !

!MetaTalkGrammar methodsFor: 'tokens' stamp: 'NickPapoulias 5/18/2011 14:18'!
boolean
	
	^ ('true' asParser / 'false' asParser) token trim ==> [:token | 
		(token value == 'true') ifTrue: [
			
				{'StackMachine pushTrue.'} asOrderedCollection.
		
			] ifFalse: [
			
				{'StackMachine pushFalse.'} asOrderedCollection.
					
			]
		
		]! !

!MetaTalkGrammar methodsFor: 'tokens' stamp: 'NickPapoulias 5/18/2011 14:18'!
char

	^ ( $$ asParser , (#word asParser / #punctuation asParser )) flatten token trim ==> [:token |
	
		{'StackMachine pushChar: ' , (token value at: 2) asInteger asString.} asOrderedCollection.
		
	]! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/18/2011 16:14'!
classDeclaration

	^ identifier , '=' asParser trim ,  identifier , '[' asParser trim , varDeclaration optional ==> [ :nodes |
		
		|className classEntry superEntry|

		className := nodes at: 1.
		superName := nodes at: 3.
		superEntry := SymbolTable search: superName.
		ivs := nodes at: 5.

		classEntry := (SymbolClassEntry new
							name: className;
							addIvs: ivs;
							addSuperIvs: superName).
							
		ivs := classEntry computedIvs.
		
		SymbolTable add: classEntry.
		
		SymbolTable new.
		
		ivs ifNotNil: [
			ivs do: [:iv | SymbolTable add: (SymbolIvEntry new name: iv)].
		].
		
	{classEntry . superEntry. } asArray.
	   
	] , methodDeclaration star, ']' asParser trim ==> [ :nodes |
	
		|classEntry superEntry methods code|
		
		SymbolTable end.
		
		classEntry := (nodes at: 1) at: 1.
		superEntry := (nodes at: 1) at: 2.
		methods := (nodes at: 2).
		
		code := OrderedCollection new.
		
		code add: (classEntry genWriteCode , 'PrimitiveCall newClass.').
	
		methods ifNotNil: [
			methods do: [:method|
					code addAll: method.
					code add: 'StackMachine push: ' , classEntry genReadCode.
					code add: 'PrimitiveCall addMethod.'
			].
		].
	
		code add: 'StackMachine push: ' , superEntry genReadCode.
		code add: 'StackMachine push: ' , classEntry genReadCode.
		code add: 'PrimitiveCall setSuper'.
		code add: 'StackMachine pushNil.'.
		code add: 'StackMachine push: ' , classEntry genReadCode.
		code add: 'PrimitiveCall setMirror'.
		code.
	]! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/18/2011 15:27'!
dict

	^ ${ asParser trim , 
		((((expression , '->' asParser token trim , expression) ==> [:nodes | {nodes at: 1. nodes at: 3} asOrderedCollection]) ,  $. asParser token trim) ==> [:nodes |  nodes at: 1]) star  , 
	$} asParser trim ==> [:nodes | 
		|size code|
		size := (nodes at: 2) size.
		code := (nodes at: 2) asOrderedCollection.
		code add: ('PrimitiveCall newDict: ' , size asString).
		code.
	].! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/18/2011 15:16'!
expression

	^ (messageSend / baseExpr) ==> [:node | node]! !

!MetaTalkGrammar methodsFor: 'tokens' stamp: 'NickPapoulias 5/18/2011 11:06'!
identifier

	^ ( #digit asParser not , (#word asParser plus) , $: asParser not) flatten token trim ==> [:token | token value]! !

!MetaTalkGrammar methodsFor: 'tokens' stamp: 'NickPapoulias 5/16/2011 15:02'!
keyword

	^ (#word asParser plus, $: asParser) flatten token trim ==> [:token | token value].! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/19/2011 13:01'!
keywordMessage

	^ ((unaryMessage / binaryMessage / baseExpr)  ,
	
	  (((keyword , (unaryMessage / binaryMessage / baseExpr)) plus) ==> [:nodes |  
		|message code|
		message := nodes inject: '' into: [:keyMsg :n | keyMsg , (n at: 1)].
		code := (nodes collect: [:n | n at: 2]) reversed. "reverse argument order"
		{message . code}
	] )) ==> [:nodes |
		|message code receiver methodEntry|
		message := (nodes at: 2) at: 1.
		code := ((nodes at: 2) at: 2) asOrderedCollection.
		receiver := nodes at: 1.
		methodEntry := SymbolTable addMethod: ((SymbolMethodEntry new) name: message). "if it exists returns the existing instance"
		code addAll: receiver.
		code add: 'PrimitiveCall call: ' , methodEntry index asString.
		code.
	]
		
	! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/18/2011 15:16'!
list

	^ (${ asParser trim , ( ( ( (expression , $. asParser token trim) ==> [:nodes | nodes at: 1]) star ) ==> [:nodes | nodes asOrderedCollection] )  , $} asParser trim) ==> [:nodes | 
		|size code|
		size := (nodes at: 2) size.
		code := (nodes at: 2).
		code add: ('PrimitiveCall newList: ' , size asString).
		code.
	].! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/19/2011 10:53'!
messageSend

	^ (keywordMessage / binaryMessage / unaryMessage) ==> [:node | node].! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/19/2011 17:12'!
methodClosure

	^ ($[ asParser trim , varDeclaration optional) ==> [:nodes |

		|locals code|
		
		locals := nodes at: 2.		
		code := OrderedCollection new.
		
		SymbolTable new.
		SymbolTable add: (SymbolLocalVarEntry new name: 'super').
		SymbolTable add: (SymbolLocalVarEntry new name: 'self').
		arguments ifNotEmpty: [
			arguments do: [:arg | SymbolTable add: (SymbolArgEntry new name: arg)].
		].
		locals ifNotNil: [
			locals do: [:local | SymbolTable add: (SymbolLocalVarEntry new name: local)].
		].
		
		code add: 'StackMachine new.'.
		code add: 'StackMachine push: ' , (SymbolTable search: superName) genReadCode.
		code add: 'StackMachine push: StackMachine prev pop'.
		
		arguments ifNotEmpty: [ 
			arguments do: [:arg | code add: 'StackMachine push: StackMachine prev pop'.]
		].
	      locals ifNotNil: [
			locals do: [:local | code add: 'StackMachine pushNil'.].
		].
		code.
	] , (primitive / statement star) optional , $] asParser trim ==> [:nodes |

		|methodIndex code methodCode|
		
		methodCode := (nodes at: 1).
		methodCode addAll: (nodes at: 2).
		methodCode add: 'StackMachine silentReturn.'.
		methodIndex := (SymbolTable addMethod: (SymbolMethodEntry new name: message)) index.  
		code := OrderedCollection new.
		
		SymbolTable end.
		
		code add: ('StackMachine push: ' ,  methodIndex asString).
		methodCode := MetaTalkGrammar flatten: methodCode.  
		code add: ('StackMachine pushBlock: ' ,  '{' , (methodCode inject: '' into: [:method :cmd | method , '''' , cmd asString , '''' , ' . ']) , '}' ).
		"code add: ('PrimitiveCall methodNew.')."
		code.
	]! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/19/2011 17:05'!
methodDeclaration

	^ ( (identifier ==> [:value | message := value . arguments := {}]) / 
	    ((binarySelector , identifier) ==> [:nodes | message := nodes at: 1. arguments := {nodes at: 2}])  /
	    ( ( (keyword , identifier) plus ) ==> [:nodes |
		 message := nodes inject: '' into: [:keyMsg :n | keyMsg , (n at: 1)] .
		 arguments := nodes collect: [:n | n at: 2]
	     ] ) )  , ':=' asParser trim , methodClosure ==> [:nodes |
		nodes at: 3.
	]! !

!MetaTalkGrammar methodsFor: 'tokens' stamp: 'NickPapoulias 5/18/2011 14:59'!
number

	^ (($- asParser optional) , #digit asParser plus , ($. asParser , (#digit asParser plus)) optional) flatten token trim ==> [:token |
		
		{'StackMachine pushNumber: ', token value} asOrderedCollection.
			
	]! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/18/2011 16:12'!
precedenceExp 

	^ $( asParser trim , expression , $) asParser trim ==> [:nodes | nodes at: 2 ].! !

!MetaTalkGrammar methodsFor: 'tokens' stamp: 'NickPapoulias 5/19/2011 17:05'!
primitive

	^ ( $< asParser trim , ($> asParser negate) plus flatten trim , $>asParser) trim ==> [:nodes |
	
		{nodes at: 2.} asOrderedCollection.
		
	]! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/19/2011 12:46'!
returnStatement
	
	^ ('^' asParser token trim , expression) ==> [:nodes |
		(nodes at: 2) add: 'StackMachine return.'.
		(nodes at: 2) asOrderedCollection.
	]! !

!MetaTalkGrammar methodsFor: 'start' stamp: 'NickPapoulias 5/19/2011 16:41'!
start

	^ ( (statement trim / classDeclaration trim) plus ) end ==> [:nodes | 
		|code| 
		code := {'SM new'. 'SM pushNil.' . 'SM pushTrue'. 'SM pushFalse.'} asOrderedCollection.
		code addAll: (MetaTalkGrammar flatten: nodes). 
		code.
	].! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/19/2011 15:37'!
statement
	
	^ ((varAssignment / expression / returnStatement) , $. asParser trim) ==> [:nodes | nodes at: 1.].! !

!MetaTalkGrammar methodsFor: 'tokens' stamp: 'NickPapoulias 5/18/2011 14:18'!
string 

	^ ($' asParser , ('''''' asParser / $' asParser negate) star flatten , $' asParser) flatten token trim ==> [:token |
		
		{'StackMachine pushString: ' , token value.} asOrderedCollection.
	]! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/19/2011 14:26'!
unaryMessage

	^ (baseExpr , identifier plus) ==> [:nodes |
		|receiverCode messageIndexes|
		receiverCode := (nodes at: 1) asOrderedCollection.
		messageIndexes := (nodes at: 2) collect: [:m | (SymbolTable addMethod: ((SymbolMethodEntry new) name: m)) index asString].
		messageIndexes do: [:mIndex | receiverCode add: 'PrimitiveCall call: ' , mIndex].
		receiverCode.
	]! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/18/2011 15:40'!
varAssignment 
	
	^ identifier , ':=' asParser token trim, expression ==>  [:nodes |
			|code|
			code := (nodes at: 3) asOrderedCollection.
			code add: (SymbolTable search: (nodes at: 1)) genWriteCode , 'SM pop'.
			code.
	].! !

!MetaTalkGrammar methodsFor: 'grammar-rules' stamp: 'NickPapoulias 5/16/2011 17:49'!
varDeclaration

	^ $| asParser trim , (identifier plus) , $| asParser trim ==> [:nodes | nodes at: 2] .! !

MetaTalkGrammar subclass: #MetaTalkParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

PPCompositeParserTest subclass: #MetaTalkGrammarTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!MetaTalkGrammarTest methodsFor: 'accessing' stamp: 'NickPapoulias 4/29/2011 11:48'!
parserClass
	"returns the grammar class in order to perform the tests"
	
	^ MetaTalkGrammar.! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 4/24/2011 16:16'!
testBinaryMessage

	self parse: '(point from: line1) + point y / 2' rule: #binaryMessage! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 3/30/2011 13:12'!
testBinarySelector 
	
	self parse: '+' rule: #binarySelector.
	self parse: '==' rule: #binarySelector.! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 3/30/2011 13:00'!
testBlockClosure! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 3/22/2011 14:24'!
testBoolean

	self parse: 'true' rule: #boolean.
	self parse: 'false' rule: #boolean.! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 3/30/2011 13:01'!
testClassDeclaration! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 4/25/2011 11:26'!
testDict! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 3/30/2011 13:01'!
testExpression! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 4/24/2011 19:09'!
testIdentifier
	"test identifiers, the actual rule is simple, just a succesion of letters"
	
	self parse: 'Object' rule: #identifier.
	self parse: 'run' rule: #identifier.! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 3/30/2011 13:24'!
testKeyword
	
	self parse: 'withArguments:' rule: #keyword.! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 4/24/2011 16:47'!
testKeywordMessage

	self parse: '((point from: line) + point y / 2) log:2 inBase: 10' rule: #keywordMessage! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 3/30/2011 13:01'!
testList! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 3/30/2011 13:01'!
testMessageSend! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 4/25/2011 00:12'!
testMethodClosure! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 3/30/2011 13:01'!
testMethodDeclaration! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 3/30/2011 13:02'!
testNumber! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 4/24/2011 16:46'!
testPrecedenceExp

	self parse: '((point from: line) + point y / 2)' rule: #precedenceExp! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 3/30/2011 13:02'!
testStart! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 4/24/2011 17:24'!
testStatement

	self parse: 'point x asString.' rule: #statement! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 3/30/2011 12:58'!
testString

	self parse: '''Hallo World''' rule: #string.
	self parse: '''Hallo '''' World''' rule: #string.! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 4/24/2011 16:09'!
testUnaryMessage
	
	self parse: '(point x + point y) asString' rule: #unaryMessage! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 3/30/2011 13:02'!
testVarAssignment! !

!MetaTalkGrammarTest methodsFor: 'test-tokens' stamp: 'NickPapoulias 3/30/2011 13:02'!
testVarDeclaration! !

MetaTalkGrammarTest subclass: #MetaTalkParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

Object subclass: #Example
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!Example class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/19/2011 17:13'!
code

^ '

Object = nil [

	initialize := [ 
		|x y z|
		x := {3. '' hallo world ''.}. 
		y := {3 -> '' hallo world ''.}.
		z := [self allocate initialize.
		(super at: 3 put: 4) allocate.
		[^ super + y + y.] value initialize.] value.
		^ z.
	]
	allocate := [
		<PrimitiveCall smth>
	]

]

'! !

!Example class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/19/2011 14:56'!
code2

^ '

Object = nil [

	initialize := [ 
		|x y z|
		x := {3. '' hallo world ''.}. 
		y := {3 -> '' hallo world ''.}.
		z := [self allocate initialize.
		(super at: 3 put: 4) allocate.
		[^ super + y + y.] value initialize.] value.
		^ z.
	]

]

'! !

Object subclass: #Kernel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!Kernel class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/23/2011 12:08'!
code

^ '

Object = nil [

	initialize := []
	= anObject := [ ^ self == anObject.]
	== anObject := [<PrimitiveCall objEq>]

]

Class = Object [
	
	allocate := [<PrimitiveCall allocate>]
	new := [
		^self allocate initialize.
	]	
	
]

Block = Object [

	value := [<PrimitiveCall blockValue>]	
	valueWithArgs: aList := [<PrimitiveCall blockValueWithArgs>]
	whileTrue: aBlock := [
		self value ifTrue: [
			aBlock value.
			self whileTrue: aBlock.
		].
	]
	
]

UndefinedObject = Object []


Number = Object [

	= aMagnitude := [<PrimitiveCall numberEq>]
	+ aNumber := [<PrimitiveCall numberAdd>]
	- aNumber := [<PrimitiveCall numberSub>]
	/ aNumber  := [<PrimitiveCall numberDiv>]
	* aNumber := [<PrimitiveCall numberMul>]
	< aNumber := [<PrimitiveCall numberLt>]
	> aNumber := [<PrimitiveCall numberGt>]
	floor := [<PrimitiveCall numberFloor>]
	ceil := [<PrimitiveCall numberCeil>]
	
]

Char = Number [
	
	asCharacter := [^ self.]	
	
]

Boolean = Object [

	| aBoolean := []
	& aBoolean	 := []
	ifTrue: aBlock := []
	ifFalse: aBlock := []
	ifTrue: aBlock ifFalse: aBlock := []
	= aBoolean := []
]

True = Boolean [

	| aBoolean := [^ true.]
	& aBoolean := [^ aBoolean.]
	not := [^ false.]
	ifTrue: aBlock := [^ aBlock value.]
	ifFalse: aBlock := [^ nil.]
	ifTrue: aBlock ifFalse: anotherBlock := [^ aBlock value.]
	
]

False = Boolean [

	| aBoolean := [^ aBoolean.]
	& aBoolean := [^ false.]
	not := [^ true.]
	ifTrue: aBlock := [^ nil.]
	ifFalse: aBlock := [^ aBlock value.]
	ifTrue: aBlock ifFalse: anotherBlock := [^ anotherBlock value.]
	
]

List = Object [

	size := [<PrimitiveCall listSize>]
	add: anObject := [<PrimitiveCall listAdd>]
	remove: anObject := [<PrimitiveCall listRemove>]
	indexOf: anObject := [<PrimitiveCall listIndexOf>]
	at: index := [<PrimitiveCall listAt>]
	at: index put: anObject := [<PrimitiveCall listAtPut>]
	= aList := [<PrimitiveCall listEq>]
	indexAndValuesDo: aBlock := [<PrimitiveCall listIndexAndValuesDo>]
	asList := [^ self.]
]

String = List [

	add: aChar := [super add: (aChar asCharacter).]
	at: index put: aChar := [super at: index put: (aChar asCharacter).]
		
]

Dict = List [

	add: aKeyValueList := [
		(aKeyValueList asList size = 2)	ifTrue: [
				super add: aKeyValueList.
		] ifFalse: [
				^ nil.
		].
	]

	remove: aKey := [
		self indexAndValuesDo: [:index :value | 
			((value at: 1) = aKey) ifTrue: [
				super remove: value.
				^ value.
			].
		].	
	]

	keyOf: aValue := [
		self indexAndValuesDo: [:index :value | 
			((value at: 2) = value) ifTrue: [
				^ value at: 1.
			].
		].	
	]

	at: key := [
		self indexAndValuesDo: [:index :value | 
			((value at: 1) = aKey) ifTrue: [
				^ value at: 2.
			].
		].				
	]

	at: key put: aValue := [
		self indexAndValuesDo: [:index :value | 
			((value at: 1) = aKey) ifTrue: [
				value at: 2 put: aValue.
				^ aValue.
			].
		].		
	]

	keysAndValuesDo: aBlock := [
		self indexAndValuesDo: [:index :value | 
			aBlock valueWithArgs: value.
		].		
	]
	
]

'! !

Object subclass: #MetaKernel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!MetaKernel class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/8/2011 22:01'!
code! !

Object subclass: #MigrationProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

Object subclass: #NetworkProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

Object subclass: #ObjectRepresentation
	instanceVariableNames: 'hostType class ivs'
	classVariableNames: 'falseRepresentation nilRepresentation trueRepresentation'
	poolDictionaries: ''
	category: 'MetaTalk'!

!ObjectRepresentation commentStamp: '<historical>' prior: 0!
Object Representation in the host language. No pre-assumptions made only slots (a smalltalk array) is present (which is equivalent of having an initial memory address and thus being able to access subsequent addresses through pointer arithmetic)

Instance Variables:
	slots	<Object>!

ObjectRepresentation subclass: #ObjectClassRepresentation
	instanceVariableNames: 'mirror superClass methodDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!ObjectClassRepresentation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 13:22'!
initialize

	super initialize.
	methodDict := Dictionary new.! !

!ObjectClassRepresentation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/1/2011 19:27'!
methodAt: index

	^ methodDict at: index.! !

!ObjectClassRepresentation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/1/2011 19:27'!
methodAt: index put: anObjectCompiledBlockRepresentation

	^ methodDict at: index put: anObjectCompiledBlockRepresentation.! !

!ObjectClassRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/12/2011 13:11'!
methodDict
	^ methodDict! !

!ObjectClassRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/16/2011 21:28'!
methodDict: anObject
	|assocDict|
	
	assocDict := anObject asDictionary.
	assocDict keysAndValuesDo: [:key :value | 
			methodDict at: key put: (ObjectCompiledBlockRepresentation new isMethod: true; compiledBlockAsHostString: value).  
	]  ! !

!ObjectClassRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/12/2011 13:11'!
mirror
	^ mirror! !

!ObjectClassRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/12/2011 13:11'!
mirror: anObject
	mirror := anObject! !

!ObjectClassRepresentation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/1/2011 19:29'!
superClass

	^ superClass.! !

!ObjectClassRepresentation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/1/2011 19:25'!
superClass: anObjectClassRepresentation

	superClass := anObjectClassRepresentation.! !

ObjectRepresentation subclass: #ObjectCompiledBlockRepresentation
	instanceVariableNames: 'compiledBlockAsHostStringList bindedStack isMethod argSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!ObjectCompiledBlockRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/8/2011 16:18'!
bindedStack
	^ bindedStack! !

!ObjectCompiledBlockRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/8/2011 16:18'!
bindedStack: anObject
	bindedStack := anObject! !

!ObjectCompiledBlockRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/18/2011 16:27'!
compiledBlockAsHostStringList
	^ compiledBlockAsHostStringList! !

!ObjectCompiledBlockRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/18/2011 16:27'!
compiledBlockAsHostStringList: anObject
	compiledBlockAsHostStringList := anObject! !

!ObjectCompiledBlockRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/16/2011 20:52'!
initialize

	super initialize.
	bindedStack := StackMachine currentStack.! !

!ObjectCompiledBlockRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/8/2011 21:22'!
isMethod
	^ isMethod! !

!ObjectCompiledBlockRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/8/2011 21:22'!
isMethod: anObject
	isMethod := anObject! !

ObjectRepresentation subclass: #ObjectDictRepresentation
	instanceVariableNames: 'hostDictRepresentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

ObjectRepresentation subclass: #ObjectListRepresentation
	instanceVariableNames: 'hostListRepresentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!ObjectListRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/17/2011 11:42'!
hostListRepresentation
	^ hostListRepresentation! !

!ObjectListRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/17/2011 11:42'!
hostListRepresentation: anObject
	hostListRepresentation := anObject! !

ObjectRepresentation subclass: #ObjectNumberRepresentation
	instanceVariableNames: 'hostNumberRepresentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!ObjectNumberRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/12/2011 15:46'!
hostNumberRepresentation
	^ hostNumberRepresentation! !

!ObjectNumberRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/12/2011 15:46'!
hostNumberRepresentation: anObject
	hostNumberRepresentation := anObject! !

!ObjectRepresentation class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/18/2011 00:00'!
createDefaultObjects
	"don't forget to set the target language classes for these default objects"
	falseRepresentation := self new hostType: false; class: ((StackMachine stackAt: 1) at: 12). 
	trueRepresentation := self new hostType: true; class: ((StackMachine stackAt: 1) at: 11). 
	nilRepresentation := self new hostType: nil; class: ((StackMachine stackAt: 1) at: 7). ! !

!ObjectRepresentation class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2011 16:02'!
falseRepresentation
	"don't forget to set the target language classes for these default objects"
	^ falseRepresentation := self new hostType: false. ! !

!ObjectRepresentation class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2011 16:00'!
initialize 
	"don't forget to set the target language classes for these default objects"
	super initialize.
	falseRepresentation := self new hostType: false. 
	trueRepresentation := self new hostType: true.
	nilRepresentation := self new hostType: nil.! !

!ObjectRepresentation class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 13:22'!
new: ivSize

	^ self new size: ivSize.! !

!ObjectRepresentation class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2011 16:01'!
nilRepresentation 
	"don't forget to set the target language classes for these default objects"
	
	^ nilRepresentation.! !

!ObjectRepresentation class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2011 16:01'!
trueRepresentation 
	"don't forget to set the target language classes for these default objects"
	^ trueRepresentation.! !

!ObjectRepresentation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/1/2011 19:24'!
at: index

	^ ivs at: index.! !

!ObjectRepresentation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/1/2011 19:24'!
at: index put: anObjectRepresentation

	^ ivs at: index put: anObjectRepresentation.! !

!ObjectRepresentation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/1/2011 19:28'!
class

	^ class.! !

!ObjectRepresentation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/1/2011 19:21'!
class: objectClassRepresentation

	class := objectClassRepresentation.! !

!ObjectRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/9/2011 13:13'!
hostType

	^ hostType! !

!ObjectRepresentation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/1/2011 19:20'!
hostType: objectRepresentationType

	hostType := objectRepresentationType.! !

!ObjectRepresentation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2011 15:54'!
initialize 

	super initialize.
	self hostType: self class.
	ivs := nil.! !

!ObjectRepresentation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2011 15:55'!
size

	ivs isNil ifTrue: [^ 0] ifFalse: [ ^ ivs size].! !

!ObjectRepresentation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 13:21'!
size: ivSize

	ivs := Array new: ivSize.! !

ObjectRepresentation subclass: #ObjectStringRepresentation
	instanceVariableNames: 'hostStringRepresentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!ObjectStringRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/17/2011 11:42'!
hostStringRepresentation
	^ hostStringRepresentation! !

!ObjectStringRepresentation methodsFor: 'accessing' stamp: 'NickPapoulias 5/17/2011 11:42'!
hostStringRepresentation: anObject
	hostStringRepresentation := anObject! !

Object subclass: #PrimitiveCall
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!PrimitiveCall commentStamp: '<historical>' prior: 0!
These are primitive calls which presume the correct inference of boundary and representation checks by the compiler and thus that vmMirrors references have been discarded.!

!PrimitiveCall class methodsFor: 'boolean' stamp: 'NickPapoulias 5/2/2011 14:29'!
boolean: selfObjectNumberRepresentation ifTrue: aCompiledBlockRepresentation! !

!PrimitiveCall class methodsFor: 'boolean' stamp: 'NickPapoulias 5/2/2011 14:30'!
boolean: selfObjectNumberRepresentation ifTrue: ifCompiledBlockRepresentation ifFalse: elseCompiledBlockRepresentation! !

!PrimitiveCall class methodsFor: 'boolean' stamp: 'NickPapoulias 5/2/2011 14:30'!
booleanNew! !

!PrimitiveCall class methodsFor: 'compiled-block' stamp: 'NickPapoulias 5/2/2011 14:31'!
compiledBlock: selfCompiledBlockRepresentation runWithArgs: anObjectListRepresentation! !

!PrimitiveCall class methodsFor: 'dictionary' stamp: 'NickPapoulias 5/2/2011 14:31'!
dict: selfObjectDictRepresentation at: anObjectRepresentation! !

!PrimitiveCall class methodsFor: 'dictionary' stamp: 'NickPapoulias 5/2/2011 14:32'!
dict: selfObjectDictRepresentation at: anObjectRepresentation put: putObjectRepresentation! !

!PrimitiveCall class methodsFor: 'dictionary' stamp: 'NickPapoulias 5/2/2011 14:32'!
dict: selfObjectDictRepresentation eq: anObjectRepresentation! !

!PrimitiveCall class methodsFor: 'dictionary' stamp: 'NickPapoulias 5/2/2011 14:33'!
dict: selfObjectDictRepresentation keysAndValuesDo: aCompiledBlockRepresentation! !

!PrimitiveCall class methodsFor: 'dictionary' stamp: 'NickPapoulias 5/2/2011 14:33'!
dictNew! !

!PrimitiveCall class methodsFor: 'list' stamp: 'NickPapoulias 5/2/2011 14:33'!
list: selfObjectListRepresentation at: anObjectNumberRepresentation! !

!PrimitiveCall class methodsFor: 'list' stamp: 'NickPapoulias 5/2/2011 14:33'!
list: selfObjectListRepresentation at: anObjectNumberRepresentation put: anObjectRepresentation! !

!PrimitiveCall class methodsFor: 'list' stamp: 'NickPapoulias 5/2/2011 14:33'!
list: selfObjectListRepresentation eq: anObjectRepresentation! !

!PrimitiveCall class methodsFor: 'list' stamp: 'NickPapoulias 5/2/2011 14:33'!
list: selfObjectListRepresentation indexAndValuesDo: aCompiledBlockRepresentation! !

!PrimitiveCall class methodsFor: 'list' stamp: 'NickPapoulias 5/2/2011 14:33'!
listNew! !

!PrimitiveCall class methodsFor: 'nil' stamp: 'NickPapoulias 5/2/2011 14:33'!
nilInstance! !

!PrimitiveCall class methodsFor: 'number' stamp: 'NickPapoulias 5/2/2011 14:33'!
number: selfObjectNumberRepresentation add: anObjectNumberRepresentation! !

!PrimitiveCall class methodsFor: 'number' stamp: 'NickPapoulias 5/2/2011 14:33'!
number: selfObjectNumberRepresentation div: anObjectNumberRepresentation! !

!PrimitiveCall class methodsFor: 'number' stamp: 'NickPapoulias 5/2/2011 14:38'!
number: selfObjectNumberRepresentation eq: anObjectNumberRepresentation! !

!PrimitiveCall class methodsFor: 'number' stamp: 'NickPapoulias 5/2/2011 14:38'!
number: selfObjectNumberRepresentation mul: anObjectNumberRepresentation! !

!PrimitiveCall class methodsFor: 'number' stamp: 'NickPapoulias 5/2/2011 14:38'!
number: selfObjectNumberRepresentation neq: anObjectNumberRepresentation! !

!PrimitiveCall class methodsFor: 'number' stamp: 'NickPapoulias 5/2/2011 14:38'!
number: selfObjectNumberRepresentation sub: anObjectNumberRepresentation! !

!PrimitiveCall class methodsFor: 'number' stamp: 'NickPapoulias 5/2/2011 14:38'!
number: selfObjectNumberRepresentation whileTrue: ifCompiledBlockRepresentation! !

!PrimitiveCall class methodsFor: 'number' stamp: 'NickPapoulias 5/9/2011 13:52'!
numberAdd

	StackMachine push: (ObjectNumberRepresentation new
	 						hostNumberRepresentation:  (StackMachine pop hostNumberRepresentation +
							 StackMachine pop hostNumberRepresentation)).    ! !

!PrimitiveCall class methodsFor: 'number' stamp: 'NickPapoulias 5/9/2011 15:00'!
numberDiv

	|a b|
	a := StackMachine pop hostNumberRepresentation.
	b := StackMachine pop hostNumberRepresentation.
	StackMachine push: (ObjectNumberRepresentation new
	 						hostNumberRepresentation:  ( b / a )).    ! !

!PrimitiveCall class methodsFor: 'number' stamp: 'NickPapoulias 5/2/2011 14:38'!
numberNew! !

!PrimitiveCall class methodsFor: 'number' stamp: 'NickPapoulias 5/2/2011 14:38'!
numberNot: selfObjectNumberRepresentation! !

!PrimitiveCall class methodsFor: 'object' stamp: 'NickPapoulias 5/2/2011 14:39'!
obj: selfObjectRepresentation at: anObjectNumberRepresentation! !

!PrimitiveCall class methodsFor: 'object' stamp: 'NickPapoulias 5/2/2011 14:39'!
obj: selfObjectRepresentation at: anObjectNumberRepresentation put: anObjectRepresentation! !

!PrimitiveCall class methodsFor: 'object' stamp: 'NickPapoulias 5/2/2011 14:39'!
obj: selfObjectRepresentation eq: anObjectRepresentation! !

!PrimitiveCall class methodsFor: 'object' stamp: 'NickPapoulias 5/2/2011 14:39'!
obj: selfObjectRepresentation id: anObjectRepresentation! !

!PrimitiveCall class methodsFor: 'object' stamp: 'NickPapoulias 5/2/2011 14:39'!
objClassOf: selfObjectRepresentation! !

!PrimitiveCall class methodsFor: 'object' stamp: 'NickPapoulias 5/2/2011 14:39'!
objClassOf: selfObjectRepresentation is: anObjectClassRepresentation! !

!PrimitiveCall class methodsFor: 'object' stamp: 'NickPapoulias 5/2/2011 14:39'!
objSize: selfObjectRepresentation! !

!PrimitiveCall class methodsFor: 'lookup' stamp: 'NickPapoulias 5/8/2011 22:11'!
send: methodId

	"take self from the stack, begin in the class of the receiver and search for methodId
	if it is not found, check if meta is enabled and begin search for doesNotUnderstand 
	from the metaClass of the receiver"! !

!PrimitiveCall class methodsFor: 'string' stamp: 'NickPapoulias 5/2/2011 14:39'!
string: selfObjectStringRepresentation add: anObjectStringRepresentation! !

!PrimitiveCall class methodsFor: 'string' stamp: 'NickPapoulias 5/2/2011 14:39'!
string: selfObjectStringRepresentation at: anObjectNumberRepresentation! !

!PrimitiveCall class methodsFor: 'string' stamp: 'NickPapoulias 5/2/2011 14:39'!
string: selfObjectStringRepresentation at: anObjectNumberRepresentation put: anObjectStringRepresentation! !

!PrimitiveCall class methodsFor: 'string' stamp: 'NickPapoulias 5/2/2011 14:39'!
string: selfObjectRepresentation eq: anObjectRepresentation! !

!PrimitiveCall class methodsFor: 'string' stamp: 'NickPapoulias 5/2/2011 14:39'!
string: selfObjectStringRepresentation indexAndCharsDo: aCompiledBlockRepresentation! !

!PrimitiveCall class methodsFor: 'string' stamp: 'NickPapoulias 5/2/2011 14:40'!
stringNew! !

Object subclass: #StackMachine
	instanceVariableNames: 'stack compiledBlock pc'
	classVariableNames: 'currentStack stackOfStacks'
	poolDictionaries: ''
	category: 'MetaTalk'!

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/17/2011 12:51'!
assignAt: index

	currentStack assignAt: index.! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 12:44'!
at: index

	^ currentStack at: index.! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 12:44'!
at: index put: anObjectRepresentation

	currentStack at: index put: anObjectRepresentation.! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 12:41'!
clear

	currentStack := nil.
	stackOfStacks := OrderedCollection new.! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 12:44'!
compiledBlock

	^ currentStack compiledBlock.    ! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 12:44'!
compiledBlock: aBlock

	^ currentStack compiledBlock: aBlock.! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/16/2011 20:52'!
currentStack

	^ currentStack.
		! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 15:33'!
end
	
	(self compiledBlock isMethod) ifTrue: [
		self prev push: (self at: 2). "push self"
		self remove.
	] ifFalse: [
		self prev push: self pop. "push last value"
		self remove.
	].! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 12:51'!
globalStack

	(stackOfStacks isEmpty) ifFalse: [
		^ stackOfStacks at: 1.
	] ifTrue: [
		^ nil
	].
		! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 4/28/2011 12:52'!
initialize

	super initialize.
	stackOfStacks := OrderedCollection new.
	currentStack := nil.! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 14:26'!
new

	currentStack := self basicNew initialize.
	stackOfStacks addLast: currentStack.
	^ currentStack.! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 12:45'!
pc

	^ currentStack pc.

  ! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 12:45'!
pcInc

	^ currentStack pcInc.

  ! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 12:45'!
pop

	^ currentStack pop.! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 14:26'!
prev

	^ stackOfStacks at: (stackOfStacks indexOf: currentStack) - 1.! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 12:45'!
push: anObjectRepresentation
	
	currentStack push: anObjectRepresentation.! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 15:30'!
remove
	
	stackOfStacks remove: currentStack.
	currentStack := stackOfStacks last.! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 15:32'!
return
	"should unwind the stack till the methodStack where the executing block originated"
	
	"all methods have the global stack as bindedStack, but this does not mean that the previous is the global"
	
	|bStack|
	
	bStack := self compiledBlock bindedStack.
	
	[ (bStack  == currentStack) not ] whileTrue: [
		self prev push: self pop.
		self remove.
	].

	(self compiledBlock isMethod) ifFalse: [
		self return.	
	] ifTrue: [
		self prev push: self pop.
		self remove.
	]! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 12:45'!
stackAt: offsetFromBindedStack

	|stack|

	stack := currentStack.

	1 to: offsetFromBindedStack abs do: [
		stack := stack compiledBlock bindedStack.
	].

	^ stack.! !

!StackMachine class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/6/2011 13:10'!
step

	Compiler evaluate: (self compiledBlock at: self pc).
	self pcInc.! !

!StackMachine methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/17/2011 12:50'!
assignAt: index

	stack at: (stack size - index + 1) put: (currentStack pop).! !

!StackMachine methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 14:57'!
at: index

	^ stack at: (stack size - index + 1).! !

!StackMachine methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 14:57'!
at: index put: anObjectRepresentation

	stack at: (stack size - index + 1) put: anObjectRepresentation.! !

!StackMachine methodsFor: 'accessing' stamp: 'NickPapoulias 5/6/2011 12:49'!
compiledBlock
	^ compiledBlock! !

!StackMachine methodsFor: 'accessing' stamp: 'NickPapoulias 5/6/2011 12:49'!
compiledBlock: anObject
	compiledBlock := anObject! !

!StackMachine methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/6/2011 13:08'!
initialize 

	super initialize.
	stack := OrderedCollection new.
	pc := 1.
	compiledBlock := ''! !

!StackMachine methodsFor: 'accessing' stamp: 'NickPapoulias 5/6/2011 12:49'!
pc
	^ pc! !

!StackMachine methodsFor: 'accessing' stamp: 'NickPapoulias 5/6/2011 12:50'!
pcInc
	pc := pc + 1.! !

!StackMachine methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 14:28'!
pop

	^ stack removeLast.! !

!StackMachine methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 14:28'!
push: anObjectRepresentation

	stack add: anObjectRepresentation.! !

!StackMachine methodsFor: 'accessing' stamp: 'NickPapoulias 5/9/2011 14:11'!
stack

	^ stack! !

!StackMachine methodsFor: 'accessing' stamp: 'NickPapoulias 5/9/2011 14:11'!
stack: anObject

	stack := anObject! !

Object subclass: #SymbolTable
	instanceVariableNames: 'scope'
	classVariableNames: 'currentScope methodList scopeList'
	poolDictionaries: ''
	category: 'MetaTalk'!

!SymbolTable class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2011 11:37'!
add: aSymbolTableEntry

	^ currentScope add: aSymbolTableEntry.
! !

!SymbolTable class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/19/2011 14:24'!
addMethod: aMethodTableEntry

	^ methodList detect: [:method | method name = aMethodTableEntry name] ifNone: [
		methodList add: (aMethodTableEntry scope: methodList).
		^ aMethodTableEntry.
	]
! !

!SymbolTable class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2011 11:34'!
clear

	currentScope := nil.
	scopeList := OrderedCollection new.
	methodList := OrderedCollection new.! !

!SymbolTable class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 16:23'!
end

	scopeList remove: currentScope.
	currentScope := scopeList last.! !

!SymbolTable class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2011 11:34'!
initialize 

	super initialize.
	scopeList := OrderedCollection new.
	currentScope := nil.
	methodList := OrderedCollection new.! !

!SymbolTable class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/16/2011 20:13'!
isGlobal

	^ ( (scopeList indexOf: currentScope) = 1)! !

!SymbolTable class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/2/2011 15:24'!
new 

	currentScope := self basicNew initialize.
	scopeList add: currentScope.
	^ currentScope.! !

!SymbolTable class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/4/2011 16:31'!
offsetFrom: aScope

	^ (scopeList indexOf: aScope) - (scopeList indexOf: currentScope).
! !

!SymbolTable class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/16/2011 20:04'!
scopeList

	^ scopeList
! !

!SymbolTable class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/4/2011 16:29'!
search: aName

	|entry|
	scopeList reversed detect: [:s | (entry := s search: aName) notNil] ifNone: [^ nil].
	^ entry.
! !

!SymbolTable class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2011 13:02'!
searchMethod: aName

	^ methodList detect: [:s | (s name = aName)] ifNone: [^ nil].
! !

!SymbolTable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/17/2011 12:34'!
add: aSymbolTableEntry

	(self search: aSymbolTableEntry name) ifNotNil: [
			scope at: (scope indexOf: (self search: aSymbolTableEntry name)) put: (aSymbolTableEntry scope: self).
		] ifNil: [
		scope add: (aSymbolTableEntry scope: self).
	].   
	! !

!SymbolTable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/4/2011 16:35'!
indexOf: anEntry

	^ scope indexOf: anEntry.  ! !

!SymbolTable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/6/2011 12:08'!
initialize 

	scope := OrderedCollection new.
	bindings := OrderedCollection new.! !

!SymbolTable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/16/2011 20:17'!
isGlobal

	^ ( (scopeList indexOf: self) = 1 )! !

!SymbolTable methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/4/2011 16:25'!
search: aName
	
	^ scope detect: [:e | e name = aName] ifNone: [nil].
! !

Object subclass: #SymbolTableEntry
	instanceVariableNames: 'name scope'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!SymbolTableEntry commentStamp: 'NickPapoulias 5/12/2011 11:46' prior: 0!
Optimally all symbolTable entries should be interconnected producing a comprehensive syntax tree of the code.
As of now only the minimum of the information required in order to compile are kept.
In the future these classes will be used for compiled time meta-information.

SymbolTableEntry has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	name	<String>
	scope	<FMRepositoryVisitor | HismoAbstractHistory | Matrix | MooseGroup | OBFan | OBList | SequenceableCollection | SymbolTable>!

SymbolTableEntry subclass: #SymbolArgEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

SymbolTableEntry subclass: #SymbolClassEntry
	instanceVariableNames: 'computedIvs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!SymbolClassEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/12/2011 11:40'!
addIv: aName

	computedIvs add: aName.! !

!SymbolClassEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/15/2011 22:17'!
addIvs: aListOfNames

	aListOfNames ifNotNil: [
		computedIvs addAll: aListOfNames.
	].! !

!SymbolClassEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/15/2011 22:16'!
addSuperIvs: aSuperClassName

	|superClass|
	superClass := SymbolTable search: aSuperClassName.
	superClass ifNotNil: [ 
		(superClass name = 'nil') not ifTrue: [
			computedIvs addAll: superClass computedIvs 
		].
	].! !

!SymbolClassEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/12/2011 11:40'!
computedIvs

	^ computedIvs! !

!SymbolClassEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/12/2011 11:40'!
initialize 

	super initialize.
	computedIvs := OrderedCollection new.! !

SymbolTableEntry subclass: #SymbolIvEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!SymbolIvEntry methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/17/2011 12:48'!
genAssignCode

	^ ' Primitive selfAssingAt: ' ,  self index asString.! !

!SymbolIvEntry methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 16:09'!
genReadCode

	^ ' Primitive selfAt: ' ,  self index asString.! !

!SymbolIvEntry methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2011 16:09'!
genWriteCode

	^ ' Primitive selfAt: ' ,  self index asString , ' put:'.! !

SymbolTableEntry subclass: #SymbolLocalVarEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

SymbolTableEntry subclass: #SymbolMethodEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaTalk'!

!SymbolTableEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/17/2011 13:12'!
genAssignCode

	(self offset = 0) ifTrue: [
		^ ' SM assignAt: ' ,  self index asString. 
	] ifFalse: [
		^ ' (SM  stackAt: ' , self offset asString , ') assignAt: ' , self index asString.
	]! !

!SymbolTableEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/16/2011 18:02'!
genReadCode

	(scope isGlobal) ifTrue:[
		^ ' (SM stackAt: 1) at: ' ,  self index asString.
	] ifFalse: [
		(self offset = 0) ifTrue: [
			^ ' SM at: ' ,  self index asString.
		] ifFalse: [
			^ ' (SM  stackAt: ' , self offset asString , ') at: ' , self index asString.
		]
	].! !

!SymbolTableEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/8/2011 21:41'!
genWriteCode

	(self offset = 0) ifTrue: [
		^ ' SM at: ' ,  self index asString , ' put: '. 
	] ifFalse: [
		^ ' (SM  stackAt: ' , self offset asString , ') at: ' , self index asString , ' put: '.
	]! !

!SymbolTableEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/4/2011 16:30'!
index

	^ scope indexOf: self.! !

!SymbolTableEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/6/2011 12:23'!
initialize

	super initialize.
	name := ''.
	scope := nil.
	bindingScope := nil.! !

!SymbolTableEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/6/2011 12:29'!
name

	^ name! !

!SymbolTableEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/2/2011 16:11'!
name: anObject

	name := anObject! !

!SymbolTableEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/6/2011 14:45'!
offset

	^ SymbolTable offsetFrom: scope.! !

!SymbolTableEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/6/2011 12:24'!
scope

	^ scope! !

!SymbolTableEntry methodsFor: 'accessing' stamp: 'NickPapoulias 5/6/2011 12:24'!
scope: anObject

	scope := anObject! !
SymbolTable initialize!
StackMachine initialize!
ObjectRepresentation initialize!
